/* -*- Mode: C; c-file-style: "stroustrup"; -*- */
#ifndef __NXP_CANVAS_CONTAINER_H__
#define __NXP_CANVAS_CONTAINER_H__

#include <glib-object.h>

#define NXP_CANVAS_CONTAINER(object)            (G_TYPE_CHECK_INSTANCE_CAST ((object),\
				nxp_canvas_container_get_type(), NxpCanvasContainer))

#define NXP_CANVAS_CONTAINER_CLASS(klass)	     (G_TYPE_CHECK_CLASS_CAST ((klass),\
				nxp_canvas_container_get_type(), NxpCanvasContainerClass))

#define NXP_IS_CANVAS_CONTAINER(object)         (G_TYPE_CHECK_INSTANCE_TYPE ((object),\
				nxp_canvas_container_get_type()))

#define NXP_IS_CANVAS_CONTAINER_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass),\
				nxp_canvas_container_get_type()))

#define NXP_CANVAS_CONTAINER_GET_CLASS(object)  (G_TYPE_INSTANCE_GET_CLASS ((object),\
				nxp_canvas_container_get_type(), NxpCanvasContainerClass))

#define NXP_CANVAS_CONTAINER_TYPE(object)       (G_TYPE_FROM_INSTANCE (object))
#define NXP_CANVAS_CONTAINER_TYPE_NAME(object)  (g_type_name (NXP_CANVAS_CONTAINER_TYPE (object)))
#define NXP_CANVAS_CONTAINER_CLASS_TYPE(klass)  (G_TYPE_FROM_CLASS (klass))
#define NXP_CANVAS_CONTAINER_CLASS_NAME(klass)  (g_type_name (NXP_CANVAS_CONTAINER_CLASS_TYPE (klass)))

#define NXP_TYPE_CANVAS_CONTAINER    (nxp_canvas_container_get_type())


/* typedef struct _NxpCanvasContainer      NxpCanvasContainer; */ /* in nxpcanvasobject.h */
typedef struct _NxpCanvasContainerClass NxpCanvasContainerClass;


#include "nxpcanvasobject.h"


struct _NxpCanvasContainer
{
    NxpCanvasObject base;

    /* object that is currently (or was last) under the pointer */
    NxpCanvasObject *in_object;	
    /* object that currently has the pointer grab, if any. */
    NxpCanvasObject *grab_object; 
    gboolean grab_is_recursive;
};


struct _NxpCanvasContainerClass
{
    NxpCanvasObjectClass base;

    GSList*          (*get_children)       (NxpCanvasContainer *container);
    NxpCanvasObject* (*get_child_at_point) (NxpCanvasContainer *self,
					    gint x, gint y);

};


GType            nxp_canvas_container_get_type           (void);
GSList*          nxp_canvas_container_get_children       (NxpCanvasContainer *self);
NxpCanvasObject* nxp_canvas_container_get_child_at_point (NxpCanvasContainer *self,
							  gint                x,
							  gint                y);
void             nxp_canvas_container_check_mouse_over   (NxpCanvasContainer *self,
							  gint                x,
							  gint                y);
void             nxp_canvas_container_pointer_grab       (NxpCanvasContainer *self,
							  NxpCanvasObject    *object,
							  gboolean            recursive);
void             nxp_canvas_container_pointer_ungrab     (NxpCanvasContainer *self);



#endif /* __NXP_CANVAS_CONTAINER_H__ */
