/* -*- Mode: C; c-file-style: "bsd"; -*- */
#ifndef __NXP_CANVAS_OVERLAY_H__
#define __NXP_CANVAS_OVERLAY_H__

#include <glib-object.h>
#include <gdk/gdk.h>



#define NXP_CANVAS_OVERLAY(object)            (G_TYPE_CHECK_INSTANCE_CAST ((object),\
				nxp_canvas_overlay_get_type(), NxpCanvasOverlay))

#define NXP_CANVAS_OVERLAY_CLASS(klass)	     (G_TYPE_CHECK_CLASS_CAST ((klass),\
				nxp_canvas_overlay_get_type(), NxpCanvasOverlayClass))

#define NXP_IS_CANVAS_OVERLAY(object)         (G_TYPE_CHECK_INSTANCE_TYPE ((object),\
				nxp_canvas_overlay_get_type()))

#define NXP_IS_CANVAS_OVERLAY_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass),\
				nxp_canvas_overlay_get_type()))

#define NXP_CANVAS_OVERLAY_GET_CLASS(object)  (G_TYPE_INSTANCE_GET_CLASS ((object),\
				nxp_canvas_overlay_get_type(), NxpCanvasOverlayClass))

#define NXP_CANVAS_OVERLAY_TYPE(object)       (G_TYPE_FROM_INSTANCE (object))
#define NXP_CANVAS_OVERLAY_TYPE_NAME(object)  (g_type_name (NXP_CANVAS_OVERLAY_TYPE (object)))
#define NXP_CANVAS_OVERLAY_CLASS_TYPE(klass)  (G_TYPE_FROM_CLASS (klass))
#define NXP_CANVAS_OVERLAY_CLASS_NAME(klass)  (g_type_name (NXP_CANVAS_OVERLAY_CLASS_TYPE (klass)))

#define NXP_TYPE_CANVAS_OVERLAY    (nxp_canvas_overlay_get_type())


typedef struct _NxpCanvasOverlay NxpCanvasOverlay;
typedef struct _NxpCanvasOverlayClass NxpCanvasOverlayClass;


#include "nxpcanvas.h"


struct _NxpCanvasOverlay
{
    GObject base;
    GdkRectangle bbox;	        /* bounding box */
    gboolean dirty:1;		/* TRUE if this object needs to be
                                   redrawn in the parent canvas */
    gboolean visible:1;
    NxpCanvas *canvas;
};


struct _NxpCanvasOverlayClass
{
    GObjectClass base;

    void (*draw) (NxpCanvasOverlay *self, GdkDrawable *drawable, GdkGC *gc, guint t);
};


GType nxp_canvas_overlay_get_type   (void);
void  nxp_canvas_overlay_draw       (NxpCanvasOverlay *self,
				     GdkDrawable      *drawable,
				     GdkGC            *gc,
				     guint             t);
void  nxp_canvas_overlay_set_canvas (NxpCanvasOverlay *self,
				     NxpCanvas        *canvas);
void  nxp_canvas_overlay_show       (NxpCanvasOverlay *self);
void  nxp_canvas_overlay_hide       (NxpCanvasOverlay *self);
void  nxp_canvas_overlay_set_bbox   (NxpCanvasOverlay *self,
				     gint              x,
				     gint              y,
				     gint              width,
				     gint              height);





#endif /* __NXP_CANVAS_OVERLAY_H__ */
