/* -*- Mode: C; c-file-style: "stroustrup"; -*- */
#ifndef __NXPLOT_GP_H__
#define __NXPLOT_GP_H__

#include "nxplot.h"
#include <libgnomeprint/gnome-print.h>

G_BEGIN_DECLS

#define NXPLOT_GP(object)\
	(G_TYPE_CHECK_INSTANCE_CAST ((object), nxplot_gp_get_type(), NxplotGP))
#define NXPLOT_GP_CLASS(klass)\
	(G_TYPE_CHECK_CLASS_CAST ((klass), nxplot_gp_get_type(), NxplotGPClass))
#define IS_NXPLOT_GP(object)\
	(G_TYPE_CHECK_INSTANCE_TYPE ((object), nxplot_gp_get_type()))
#define IS_NXPLOT_GP_CLASS(klass)\
	(G_TYPE_CHECK_CLASS_TYPE ((klass), nxplot_gp_get_type()))
#define NXPLOT_GP_GET_CLASS(object)\
  (G_TYPE_INSTANCE_GET_CLASS ((object), nxplot_gp_get_type(), NxplotGPClass))
#define NXPLOT_GP_TYPE(object)       (G_TYPE_FROM_INSTANCE (object))
#define NXPLOT_GP_TYPE_NAME(object)  (g_type_name (NXPLOT_GP_TYPE (object)))
#define NXPLOT_GP_CLASS_TYPE(klass)  (G_TYPE_FROM_CLASS (klass))
#define NXPLOT_GP_CLASS_NAME(klass)  (g_type_name (NXPLOT_GP_CLASS_TYPE (klass)))
#define TYPE_NXPLOT_GP		nxplot_gp_get_type()
#define NXPLOT_TYPE_GP		nxplot_gp_get_type()


typedef struct _NxplotGP      NxplotGP;
typedef struct _NxplotGPClass NxplotGPClass;
typedef struct _NxplotGPState NxplotGPState;


struct _NxplotGPState {
    double   last_x, last_y; /* last endpoint of a line command
				(cursor position) */
    double   path_start_x;   /* point where current path started */
    double   path_start_y;
    double   linewidth;
    GQuark   font_name;
    double   font_size;
    double   text_angle;
    GdkColor fillcolor;
    double   fillopacity;
    guint32  foreground;
    double   ctm[6];
};


struct _NxplotGP
{
    Nxplot             base;
    GnomePrintContext *pc;
    gboolean           inpath:1;        /* TRUE when a path is under construction */
    NxplotGPState      state;	        /* current state */
    GQueue            *saved_states;	/* Stack of saved states (elements are
					   of type (NxplotGPState *) ) */
    GnomeFont         *font;
};



struct _NxplotGPClass
{
    NxplotClass base;
};



GType   nxplot_gp_get_type (void);
Nxplot* nxplot_gp_new      (GnomePrintContext *pc);



G_END_DECLS

#endif /* __NXPLOT_GP_H__ */

